import org.jetbrains.kotlin.gradle.tasks.KotlinCompile

plugins {
    kotlin("jvm") version "1.8.0-dev-1839"
    id("org.jetbrains.kotlinx.kover") version "0.6.0-Beta"
    application
}

group = "org.example"
version = "1.0-SNAPSHOT"

repositories {
    mavenCentral()
    maven("https://maven.pkg.jetbrains.space/kotlin/p/kotlin/dev")
}

dependencies {
    testImplementation(kotlin("test"))
}

tasks.test {
    useJUnitPlatform()
}

tasks.withType<KotlinCompile> {
    kotlinOptions.jvmTarget = "1.8"
}

application {
    mainClass.set("MainKt")
}

kover {
    htmlReport {
        onCheck.set(true)
    }

    verify {
        onCheck.set(true)
        rule {
            isEnabled = true
            name = "test"
            target = kotlinx.kover.api.VerificationTarget.ALL

            bound { // add rule bound
                minValue = 10
                maxValue = 10
                counter = kotlinx.kover.api.CounterType.INSTRUCTION
                valueType = kotlinx.kover.api.VerificationValueType.MISSED_COUNT
            }
        }
    }
}